#!/bin/ksh
#


usage() {
echo "usage: $0 MSGFILE MSGNO DEFAULTMSG" 
exit 1
}


get_OSF1_message() {
QMSG=`/opt/pdweb-lite/bin/pdwslgetmsg $MSG_FILE $MSG_NO $MSG_DEFAULT`
echo ${QMSG}
}




# parse the command line
# do not support printf style message in this environment 
export NLSPATH=/opt/pdweb-lite/nls/msg/%L/%N
export TISDIR=/opt/pdweb-lite/nls


if [ "$#" -ne 3 ]; then
    usage 
fi

OSTYPE=`uname -s`

MSG_FILE="$1"
MSG_NO="$2"
MSG_DEFAULT="$3"
 

case "$OSTYPE" in 
	SunOS ) get_OSF1_message;;
	AIX ) get_OSF1_message;;
	OSF1 ) get_OSF1_message;;
	HP-UX ) get_HP_message;;
	Linux ) get_OSF1_message;;
	*) echo "$OSTYPE" not supported
	   exit 1;;
esac
