#!/bin/ksh
##############################################################################
#Message ID's for NLS
##############################################################################
# $01 iwatkins support multiple registries

MSG_PACKAGE_NOT_INSTALLED=1
MSG_PACKAGE_VERSION_WRONG=2
MSG_JAVALIB_ERROR=11
MSG_JAVAJAR_ERROR=12
MSG_JAVABIN_ERROR=13
MSG_LDAP_CHOICE_ERROR=14
MSG_COPY_ERROR=15
MSG_MISSINGWTECONFFILE=16
MSG_UNSUPPOS=17
MSG_ROOTWARN=18
MSG_STOPSERVER=19
MSG_WARNNOSTOPSERVER=20
MSG_LDAPHOSTUNDEFINED=21
MSG_LDAPPORTNOTVALID=22
MSG_LDAPHOST_NOTDEFINED=23
MSG_LDAPADMINUSER_NOTDEFINED=24
MSG_LDAPADMINPWD_NOTDEFINED=25
MSG_SSL_NOTDEFINED=26
MSG_KEYFILE_NOTDEFINED=27
MSG_KEYFILEDN_NOTDEFINED=28
MSG_KEYFILEPWD_NOTDEFINED=29
MSG_PDADMINUSER_NOTDEFINED=30
MSG_PDADMINPWD_NOTDEFINED=31
MSG_WTEPORT_NOTDEFINED=32
MSG_INVALID_HOSTNAME=33
MSG_JAVADIR_EMPTY=34
MSG_COOKIECREATE=35
MSG_COOKIECREATE_SUCCESS=36
MSG_COOKIECREATE_ERROR=37
MSG_INVALID_HOSTNAME=38
MSG_SVRSSLCFG_ERROR=39
MSG_CP_QUERYCONENT_ERROR=40
MSG_OBJSPACESETUP_ERROR=41
MSG_OBJCREATE_ERROR=42
MSG_ACLCREATE_ERROR=43
MSG_ACLMODIFY_ERROR=44
MSG_ACLATTACH_ERROR=45
MSG_STARTING_WTE=46
MSG_WESOSM_ERROR=47
MSG_CONFIG_COMPLETE=48
MSG_JAVAJVM_ERROR=49
MSG_LDAPSERVERHOST=50
MSG_LDAPSERVERPORT=51
MSG_LDAPADMINUSERDN=52
MSG_LDAPADMINUSERPWD=53
MSG_LDAPSSL=54
MSG_LDAPSSLKEYFILE=55
MSG_LDAPSSLDN=56
MSG_LDAPKEYFILEPWD=57
MSG_LDAPSERVERSSLPORT=58
MSG_LDAPSSLPORT_NOTDEFINED=59
MSG_GETHOSTNAME=60
MSG_GETWTEPORT=61
MSG_PDADMIN=62
MSG_PDPASSWORD=63
MSG_USEPD=64
MSG_GETJAVADIR=65
MSG_FAILOVER_COOKIE_ERROR=66

#temp var so that messages won't be seen when
#detecting WTE install dir in getWTEPackageInfo
ERRORLOG=/dev/null



##############################################################################
#
# initialize
# 
#
# This function setups up certain variables
#
##############################################################################
initialize()
{
   case "$OSTYPE" in
   SunOS )
      WSLINSTALLDIR="/opt/pdweb-lite"
      WSLLIBDIR=$WSLINSTALLDIR/lib
      WSLBINDIR=$WSLINSTALLDIR/bin
      WSLCONFDIR=$WSLINSTALLDIR/etc
      WSLJAVADIR=$WSLINSTALLDIR/classes
      QUERYCONTENTSDIR="$WSLBINDIR"
      PDDIR="/opt/PolicyDirector"
      PDRTEDIR="$PDDIR/bin"


      ;;
   AIX )
      WSLINSTALLDIR="/opt/pdweb-lite"
      WSLLIBDIR=$WSLINSTALLDIR/lib
      WSLBINDIR=$WSLINSTALLDIR/bin
      WSLCONFDIR=$WSLINSTALLDIR/etc
      WSLJAVADIR=$WSLINSTALLDIR/classes
      QUERYCONTENTSDIR="$WSLBINDIR"
      PDDIR="/opt/PolicyDirector"
      PDRTEDIR="$PDDIR/bin"

      ;;
   Linux )
      WSLINSTALLDIR="/opt/pdweb-lite"
      WSLLIBDIR=$WSLINSTALLDIR/lib
      WSLBINDIR=$WSLINSTALLDIR/bin
      WSLCONFDIR=$WSLINSTALLDIR/etc
      WSLJAVADIR=$WSLINSTALLDIR/classes
      QUERYCONTENTSDIR="$WSLBINDIR"
      PDDIR="/opt/PolicyDirector"
      PDRTEDIR="$PDDIR/bin"

      ;;
   esac
   
}

##############################################################################
#
# CleanUp()
#
#       This code will cleanup /unconfig
#
##############################################################################
CleanUp()
{
   if [ "$UNCONFIG" = "YES" ]
    then
      ACLATTACH=YES
     	ACLCREATEOKAY=YES
    	CONFFILESCOPIED=YES
	CONFIGUREDWTE=YES
	COPYQUERYCONTENTS=YES
	CREATEDUSRLIBLINK=YES
	SVRSSLCFGOKAY=YES
      REMOVEOBJECTSPACE=YES

     if [ "$USEPD" = "TRUE" ]
       then
         #make sure we have PD password and user id
    	   if [ -z "$ADMINUSER" -o "$ADMINPASSWORD" ]
           then
             getAdminAndPassword
         fi
     fi

	if [ "$HOSTNAMEINVALID" = "YES" ]
        then
          gethostname
      fi

   fi

###########################
#Don't remove the acl
###########################

# if [ "$USEPD" = "TRUE" ]
#   then
#
#   if [ "$ACLATTACH" = "YES" ]
#      then
#        $PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl detach "$BRANCH" >> $ERRORLOG 2>&1    
#   fi

#  if [ "$ACLCREATEOKAY" = "YES" ]
#   then
#    ACLINFO=`$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl list | awk '{if($1=="'$ACLNAME'") {print $1} }'`
#    if [ -n "$ACLINFO" ]; then
#        echo acl delete "$ACLNAME"
#       $PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl delete "$ACLNAME" >> $ERRORLOG 2>&1
#    fi
#  fi
#fi


   
   # Erase any of the changes made
   if [ "$CONFFILESCOPIED" = "YES" ]
     then
       undobackupcopyconffile WSL "$GENERALCONF"
	 undobackupcopyconffile WSL "$OSDEFCONF"
	 undobackupcopyconffile WSL "$USERMAPCONF"
   fi


   if [ "$CONFIGUREDWTE" = "YES" ]
     then
        undobackupcopyconffile WTE "$IBMPROXYCONF"

        for conf_file in `find $WTEINSTALLDIR -type f -name ibmproxy.conf`
         do
              undobackupcopyconffile WTE "$conf_file"
         done

   fi

   if [ "$COPYQUERYCONTENTS" = "YES" ]
     then
       FILETOREMOVE="$SERVERROOT/cgi-bin/query_contents"
	 [ -f $FILETOREMOVE ] && rm -f $FILETOREMOVE
   fi



   # unlink the stuff put in /usr/lib -?
  if [ "$CREATEDUSRLIBLINK" = "YES" ]
    then
      [ -f /usr/lib/$PLUGINLIBNAME ] && rm -f /usr/lib/$PLUGINLIBNAME 
  fi

 if [ "$USEPD" = "TRUE" ]
   then

   # do an unconfig w/ svrsslcfg if the user entry exists
   if [ "$SVRSSLCFGOKAY" = "YES" ]
     then
        OBJSPACE=`$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" user list  "$WSLSERVERNAME""*" 500 | awk '{if($1=="'$WSLSERVERNAME/$SVRSSLHOSTNAME'") {print $1} }'`
        if [ -n "$OBJSPACE" ]; then
          echo "$PDRTEDIR/svrsslcfg -f \"$POLICYDIRSSLFILE\" -unconfig -n \"$WSLSERVERNAME/$SVRSSLHOSTNAME\""
          $PDRTEDIR/svrsslcfg -f "$POLICYDIRSSLFILE" -unconfig -n "$WSLSERVERNAME/$SVRSSLHOSTNAME" -P "$ADMINPASSWORD"
        fi
   fi

  # Delete the kdb and sth files
  rm -f $WSLCONFDIR/*.kdb
  rm -f $WSLCONFDIR/*.sth

fi
 
}

##############################################################################
#
# exitFailure()
#
#       Exit on an error
#
##############################################################################

exitFailure()
{

   CleanUp
   exit 1
}

###########################################
# backupcopyconffile
# 
# This function will check to see if a config file exist
# if it does exist then it will copy the file to a backup.
# 
# if the files doesn't exist then for WSL files it will attempt
# to copy the template file.  However, if the WTE file doesn't
# exist then there is an error.
#
# $1  WSL | WTE 
#     (WSL - means this is a Access Manager Plug-in for Edge Server conf file)   
#     (WTE - means this is a Web Traffic Express conf file)   
#
# $2  configfile
###########################################
backupcopyconffile()
{
    CONF_FILE_TYPE=$1
    CONF_FILE=$2

    DOESCONFFILEEXIST=YES 


    #########################################################
    #if this is a Access Manager Plug-in for Edge Server file then make sure it exists
    #so that if it doesn't the template file can be copied
    #########################################################
    if [ "$CONF_FILE_TYPE" = "WSL" ]
      then
        [ ! -f "$CONF_FILE" ] && DOESCONFFILEEXIST=NO
    fi

    if [ "$DOESCONFFILEEXIST" = "YES" ]
     then
        ############################################
        #check to see if backup file already exists
        #if so then call the file bak.year.month.day.hour.minute.second
        ############################################
        EXTENSION="$BACKUPEXTENSION"
        [ -f $CONF_FILE$EXTENSION ] && EXTENSION="$BACKUPEXTENSION.$$"
        cp $CONF_FILE $CONF_FILE$EXTENSION
        rc=$?
        if [ $rc -ne 0 ]
           then
             $PDRDAMSG pdwslshmsg.cat "$MSG_COPY_ERROR" "ERROR: Configuration file copy error"
             exitFailure
        fi

    else
       if [ "$CONF_FILE_TYPE" = "WSL" ]
         then
            cp $CONF_FILE.template $CONF_FILE
            rc=$?
            if [ $rc -ne 0 ]
               then
                 $PDRDAMSG pdwslshmsg.cat "$MSG_COPY_ERROR" "ERROR: Configuration file copy error"
                 exitFailure
            fi
       else
            #Since the WTE conf file doesn't exist this is an error!!!
             $PDRDAMSG pdwslshmsg.cat "$MSG_MISSINGWTECONFFILE" "ERROR: The WTE configuration file is missing"
            exitFailure
       fi
     fi

}

###########################################
# undobackupcopyconffile
# 
# This function undo any copying that
# took place of a conf file.
# 
#
# $1  WSL | WTE 
#     (WSL - means this is a Access Manager Plug-in for Edge Server conf file)   
#     (WTE - means this is a Web Traffic Express conf file)   
# $2  configfile
###########################################
undobackupcopyconffile()
{
    CONF_FILE_TYPE=$1
    CONF_FILE=$2
    #########################################################
    #Check to see if a version was created using this particular
    #instance of the config.
    #########################################################    
   if [ "$UNCONFIG" = "YES" ]
    then
       #########################################################  
       #Preserve the conf file for WSL files.
       #########################################################  
       if [ "$CONF_FILE_TYPE" = "WTE" ]
         then
          if [ -f "$CONF_FILE$BACKUPEXTENSION" ]
            then
                echo y | cp $CONF_FILE$BACKUPEXTENSION $CONF_FILE
          fi
       fi
   else    
     if [ -f "$CONF_FILE$BACKUPEXTENSION.$$" ]
       then
          echo y | cp $CONF_FILE$BACKUPEXTENSION.$$ $CONF_FILE
     elif [ -f "$CONF_FILE$BACKUPEXTENSION" ]
       then
          echo y | cp $CONF_FILE$BACKUPEXTENSION $CONF_FILE
     fi
  fi

    #Cleanup any extra backup copies
    for filename in `ls $CONF_FILE*`
     do
      if [ "$filename" != "$CONF_FILE" -a \
          "$filename" != "$CONF_FILE$BACKUPEXTENSION" -a \
          "$filename" != "$CONF_FILE$BACKUPEXTENSION.$$" -a \
          "$filename" != "$CONF_FILE.template" ]
     then
        rm -f $filename
     fi
    done

}


##############################################################################
#
# isPackageInstalled
#
# $1 - The package name
#
# This function determines if a package is installed.
# Returns  0    for Yes it is installed
#          1    if it is not installed
#          2    wrong version
#
##############################################################################
isPackageInstalled()
{
  PKGID=$1
  VERSION=$2

   case "$OSTYPE" in
      SunOS )
         pkginfo $PKGID >> $ERRORLOG 2>&1
         if [ $? -ne 0 ]
         then
             return 1
         else
            #PD changed the format of their version. This code has to 
            #modified to check both formats
            NUMBEROFFIELDS=`pkginfo -x $PKGID | tail -1 | awk '{print NF}'`
            if [ $NUMBEROFFIELDS -eq 2 ]
             then
                 LDAPVERSION=`pkginfo -x $PKGID | tail -1 | awk '{print $2}'`
            else
                 LDAPVERSION=`pkginfo -x $PKGID | tail -1 | awk '{print $3 "." $6}'`
            fi

             LDAP_MAJOR_VERSION=`echo $LDAPVERSION | cut -d\. -f1-3`
             n1=`echo $LDAP_MAJOR_VERSION | cut -d\. -f1`
             n2=`echo $LDAP_MAJOR_VERSION | cut -d\. -f2`
             n3=`echo $LDAP_MAJOR_VERSION | cut -d\. -f3 | cut -b1`
             [ -z "$n3" ] && n3=0

             newValue=`echo $n1$n2$n3`

            if [ $newValue -lt $VERSION ]; then
               return 2
            fi
	    return 0
          fi
          ;;
      AIX )
         lslpp -ql $PKGID >> $ERRORLOG 2>&1
         if [ $? -ne 0 ]
         then
             return 1
         else
            LDAPVERSION=`lslpp -qlc $PKGID |  head -n 1 | awk -F: '{print $3}'`
            n1=`echo $LDAPVERSION | cut -d\. -f1`
            n2=`echo $LDAPVERSION | cut -d\. -f2`
            n3=`echo $LDAPVERSION | cut -d\. -f3`
            [ -z "$n3" ] && n3=0
            newValue=`echo $n1$n2$n3`
            if [ $newValue -lt $VERSION ]; then
                 return 2
            fi
	    return 0
         fi
        ;;
      Linux )
	rpm -q $PKGID >> $ERRORLOG 2>&1
        if [ $? -ne 0 ]; then
             return 1
        else
            v=`rpm -q --queryformat '%{VERSION}' $PKGID`
            n1=`echo $v | cut -d\. -f1`
            n2=`echo $v | cut -d\. -f2`
            n3=`echo $v | cut -d\. -f3`
            [ -z "$n3" ] && n3=0
            newValue=`echo $n1$n2$n3`
            if [ $newValue -lt $VERSION ]; then
                 return 2
            fi
	    return 0
        fi
        ;;
    esac
}

##############################################################################
#
# getWTEPackageInfo()
#
##############################################################################
getWTEPackageInfo() 
{
   #
   # Find out if the user is root (uid=0) if not then terminate.
   #
   case "$OSTYPE" in
   SunOS )
      WTEPACKAGE="WSEScp"
      WTEPACKAGE2="WSEScp.2"
      WTEVERSION="401"
	WTECONFDIR="/etc"
      ;;
   AIX )
      WTEPACKAGE="wses_cp.base"
      WTEVERSION="401"
	WTECONFDIR="/etc"

      ;;
   Linux )
      WTEPACKAGE="WSES_CachingProxy"
      WTEVERSION="401"

	WTECONFDIR="/etc"
      ;;
   esac

      WTEINSTALLDIR=/opt/ibm/edge/cp
      WTE_VER=4
}


##############################################################################
#
# getLDAPPackageInfo()
#
##############################################################################
getLDAPPackageInfo() 
{ 
   #
   # Find out if the user is root (uid=0) if not then terminate.
   #
   case "$OSTYPE" in
   SunOS )
     LDAPPKGNAME="IBMldapc"
     LDAPVERSION="320"
      ;;
   AIX )
      LDAPPKGNAME="ldap.client.rte"
      LDAPVERSION="311"
      ;;
   Linux )
      LDAPPKGNAME="ldap-client"
      LDAPPKGNAME2="ldap-clientd"
      LDAPVERSION="311"
      ;;
   esac
}

##############################################################################
#
# getPDPackageInfo()
#
##############################################################################
getPDPackageInfo() 
{

  #
   # Find out if the user is root (uid=0) if not then terminate.
   #
   case "$OSTYPE" in
   SunOS )
      PDRTEPKGNAME="PDRTE"
      PDRTEVERSION="390"
      ;;
   AIX )
      PDRTEPKGNAME="PD.RTE"
      PDRTEVERSION="390"
      ;;
   Linux )
      PDRTEPKGNAME="PDRTE-PD"
      PDRTEVERSION="390"
      ;;

   esac
}

##############################################################################
#
# getJavaRTEPackageInfo()
#
##############################################################################
getJavaRTEPackageInfo() 
{

   #
   # Find out if the user is root (uid=0) if not then terminate.
   #
   case "$OSTYPE" in
   SunOS )
      JAVARTE="Unknown"
      JAVARTEVERSION="nope"
      ;;
   AIX )
      JAVARTEBIN="Java130.rte.bin"
      JAVARTECLASSES="Java130.rte.lib"
      JAVAVERSION="130"
      ;;
   Linux )
      JAVARTE="IBMJava2-JRE"
      JAVARTEVERSION="13"
      ;;
   esac
}

##############################################################################
#
# mapBoolean()
#
#       Maps a boolean variable to particular strings for true and false
#
#       $1 - name of variable to change
#       $2 - string for true
#       $3 - string for false
#
##############################################################################
mapBoolean()
{
   VARNAME=$1
   TRUE_STRING=$2
   FALSE_STRING=$3
   eval TMPVAL="\$$VARNAME"

   case "$TMPVAL" in
   y|Y|yes|YES|Yes|TRUE|true)
      TMPVAL=$TRUE_STRING
      ;;
   *)
      TMPVAL=$FALSE_STRING
      ;;
   esac

   eval $VARNAME=$TMPVAL
}


##############################################################################
#
# checkRootId
#
#    Checks that the current user is root
#
##############################################################################
checkRootId () {

   #
   # Find out if the user is root (uid=0) if not then terminate.
   #
   case "$OSTYPE" in
   SunOS )
      USERID=`id | awk -F= '{print $2}' | awk -F\( '{print $1}'`
      ;;
   OSF1 | HP-UX | UNIX_SV | SCO_SV | AIX | Linux )
      USERID=`id -u`
      ;;
   * ) $PDRDAMSG pdwslshmsg.cat "$MSG_UNSUPPOS" "ERROR: Unsupported operating system type:"
      exitFailure
      ;;
   esac

   if [ "$USERID" -ne 0 ]
   then
       $PDRDAMSG pdwslshmsg.cat "$MSG_ROOTWARN" "WARNING: this script must be executed by 'root' (uid = 0)."
       echo
       exitFailure
   fi

}


##############################################################################
#
# getServerPID()
#
#       Returns the PID of a process, if any
#
#       $1 - processs name to locate
#
##############################################################################
getServerPID()
{
    SERVERNAME=$1

    # Convert output of ps into <pid> <procname>, then check for <name> and
    # print <pid>
    # Bug Fix (2313)

    # UNIX95 enables XPG4 capabilities of ps for HP-UX i.e. -o
    UNIX95=1
    export UNIX95

   if [ "$OSTYPE" = "SunOS" ]
      then
         PIDCOMMAND=comm
    else
         PIDCOMMAND=command
    fi
    SERVERPID=`ps -eo pid,$PIDCOMMAND | fgrep $SERVERNAME | awk '{print $1}'`
    SERVERPID=`echo $SERVERPID | awk '{print $1}'`

}


##############################################################################
#
# waitServerDeath()
#
#       Wait for a process to die
#
#       $1 - PID of process to watch
#       $2 - max number of seconds to wait
#
#       Sets SERVERDEAD to TRUE if the process is dead
#
##############################################################################
waitServerDeath()
{
    PID=$1
    TIMEOUT=$2
    SERVERDEAD=FALSE

    CURTIME=0
    while [ $CURTIME -lt $TIMEOUT ]
    do
        ps -p $PID | grep $PID > /dev/null 2>&1
        if [ $? -ne 0 ]; then
            SERVERDEAD=TRUE
            return
        fi
        sleep 1
        CURTIME=`expr $CURTIME + 1`
    done
}


##############################################################################
#
# killServer()
#
#       Checks whether a process is running, and kills it if so.
#
#       $1 - process name to locate
#
##############################################################################
killServer()
{
    getServerPID $1
    if [ "$SERVERPID" != "" ]
    then
        # Do a soft kill first
        #echo "    Stop the $1"
        QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_STOPSERVER" "Stopping the: "`
        echo "$QMSG" $1
        kill $SERVERPID >> $ERRORLOG 2>&1

        # Wait for process to die
        waitServerDeath $SERVERPID 30
        if [ "$SERVERDEAD" = TRUE ]
        then
            return
        fi

        # Hard kill
        kill -9 $SERVERPID >> $ERRORLOG 2>&1
        waitServerDeath $SERVERPID 5
        if [ "$SERVERDEAD" != TRUE ]
        then
            QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_WARNNOSTOPSERVER" "WARNING: Could not stop the: "`
            echo "$QMSG" $1
        fi
    fi
}




##############################################################################
# queryUser()
#
#       Prompts user for some input
#
#       Accepts a command line:
#            RtnVar Message EchoFlag
#
#       The value in the RtnVar is used as a default, and the result is
#       stored in there.
#
#       Message is the text to display.
#
#       The EchoFlag is TRUE or FALSE indicating whether to echo the user's
#       input.
#
##############################################################################

queryUser()
{
    if [ $# -lt 3 ]
    then
        echo "ERROR: too few arguments to queryUser"
        exit 1
    fi
    DEFAULT=`eval echo '"'"$"$1'"'`
    QMSG="$2"
 
    echo "   " 
    echo "   " 
    echo "   " 
    echo ${QMSG}
    if [ $3 = TRUE ]
    then
        stty -echo echonl
    fi

    read INSTR
  
    if [ $3 = TRUE ]
    then
        stty echo -echonl
    fi
    
    echo $INSTR | grep \" 2>&1 > /dev/null
    if [ $? -eq 0 ]; then
      HASQUOTES=TRUE
    else
      HASQUOTES=FALSE
    fi
    
    if [ "$INSTR" != "" ]
    then
	if [ "$HASQUOTES" = "TRUE" ]
	then
	    eval $1="$INSTR"
	else
            eval $1='"'"$INSTR"'"'
	fi
    fi
}

##############################################################################
#
# queryUserYesNo()
#
#       Prompts user for a yes/no response
#
#       Accepts a command line:
#            RtnVar Message
#
##############################################################################
queryUserYesNo()
{
    if [ $# -lt 2 ]
    then
        echo "ERROR: too few arguments to queryUserYesNo"
        exit 1
    fi
    mapBoolean $1 Yes No
    queryUser "$1" "$2" FALSE
    mapBoolean $1 TRUE FALSE
}



##############################################################################
#
# ldapGetHostPort()
#
# This function prompts the user for the ldap hostname and ports
#
##############################################################################
ldapGetHostPort()
{
   # prompt for ldap server information

   case "$OSTYPE" in 
       "HP-UX" ) PING="ping";; 
       "SunOS" ) PING="ping";; 
       "AIX" ) PING="ping -c1";;
       "Linux" ) PING="ping";;
       *) PING="ping";; 
   esac

   LDAPHOST=""
   CONTINUE=TRUE
   while [ "$CONTINUE" = TRUE ]
   do
       echo " "

       echo " "
       QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_LDAPSERVERHOST" "Enter the LDAP server hostname:"`
       queryUser LDAPHOST "$QMSG" FALSE

       if [ "$OSTYPE" = "HP-UX" ]; then
          echo "hpux"
          #$PING $LDAPHOST -n 1 >> $ERRORLOG 2>&1
          #retval=$?
       elif [ "$OSTYPE" = "Linux" ]; then 
          $PING $LDAPHOST -c 2 >> $ERRORLOG 2>&1
          retval=$?
       else
       
          $PING $LDAPHOST >> $ERRORLOG 2>&1
          retval=$? 
       fi

       if [ $retval -ne 0 ]; then
         $PDRDAMSG pdwslshmsg.cat "$MSG_LDAPHOSTUNDEFINED" "WARNING: LDAP server hostname does not exist"
	 CONTINUE=TRUE
       else
	 CONTINUE=FALSE
       fi
  done

  LDAPPORT=389
  CONTINUE=TRUE
  while [ "$CONTINUE" = TRUE ]
  do
      echo ""
      QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_LDAPSERVERPORT" "Enter the LDAP server port number [389]:"`

      queryUser LDAPPORT "$QMSG" FALSE
	
      [ $LDAPPORT -ge 1 ] >> $ERRORLOG 2>&1
      if [ $? -ne 0 ]; then
	$PDRDAMSG pdwslshmsg.cat "$MSG_LDAPPORTNOTVALID" "WARNING: LDAP server port must be a number and greater than zero"
        CONTINUE=TRUE
      else
	CONTINUE=FALSE
      fi
  done

}

##############################################################################
# ldapCheckHostPort()
# check the LDAPHOST
# the LDAPHOST variable should be set
# no user input take place in this function
#
# return values:
# 1 LDAPHOST or LDAPPORT is not set
#
##############################################################################
ldapCheckHostPort()
{
   # check that LDAPHOST is set and not NULL
   if [ -z "$LDAPHOST" ]; then
      $PDRDAMSG pdwslshmsg.cat "$MSG_LDAPHOST_NOTDEFINED" "ERROR: LDAPHOST not set."
      return 1
   fi

   if [ -z "$LDAPPORT" ]; then
      $PDRDAMSG pdwslshmsg.cat "$MSG_LDAPPORT_NOTDEFINED" "ERROR: LDAPPORT not set."
      return 1
   fi

   # add ldap server information to ldap.conf

   return 0  
}

##############################################################################
#
# ldapGetAdmin()
#
# This function prompts the user for the ldap admin user and password
#
##############################################################################
ldapGetAdmin()
{
    #
    # ask for the LDAP administrative username/password information
    #

   CONTINUE=FALSE
   # loop till it works
   while [ "$CONTINUE" = FALSE ]
   do
     LDAPADMINUSER="cn=root"
     QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_LDAPADMINUSERDN" "Enter the LDAP administrative user DN [cn=root]:"`

     queryUser LDAPADMINUSER "$QMSG" FALSE

     LDAPADMINUSERPWD=""
     while [ ! -n "$LDAPADMINUSERPWD" ]
       do
         QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_LDAPADMINUSERPWD" "Enter the LDAP administrative user password:"`

         queryUser LDAPADMINUSERPWD  "$QMSG" TRUE
       done

     ################  NOTE ######################
     # PDWeb_config calls a utility called ivrgy_tool 
     # that appears to do a bind to make sure all is working with LDAP
     # Add this later when you know how to make this work (packaging wise)
  
     if [ -n "$LDAPADMINUSER" ]; then 
       CONTINUE=TRUE
     fi
   done
}

##############################################################################
# ldapCheckAdmin()
#
##############################################################################
ldapCheckAdmin()
{
   # check that LDAPADMINUSER and LDAPADMINUSERPWD are set and not NULL
   # assume LDAPHOST and LDAPPORT are available

   if [ -z "$LDAPADMINUSER" ]; then
      $IVBIN$PDRDAMSG pdwslshmsg.cat "$MSG_LDAPADMINUSER_NOTDEFINED" "ERROR: LDAPADMINUSER not set."
      return 1
   fi

   if [ -z "$LDAPADMINUSERPWD" ]; then
      $PDRDAMSG pdwslshmsg.cat "$MSG_LDAPADMINPWD_NOTDEFINED" "ERROR: LDAPADMINPWD not set."
      return 1
   fi

  ################  NOTE ######################
  # PDWeb_config calls a utility called ivrgy_tool 
  # that appears to do a bind to make sure all is working with LDAP
  # Add this later when you know how to make this work (packaging wise)

  return 0
}

##############################################################################
#
# ldapGetSSL()
#
# This function prompts the user to find out if they want to enable
# SSL communication.
# The user is prompted for for the ldap server SSL information
# (keyfile, keyfile password, port) if SSL is enabled.
#
##############################################################################
ldapGetSSL()
{

    LDAPSSLPORT=636
    TMP_LDAPPORT=$LDAPPORT

    #
    # ask for SSL communication
    #
    CONTINUE=FALSE
    while [ "$CONTINUE" = "FALSE" ]
      do
        SSL="Yes"

        QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_LDAPSSL" "Do you want to enable SSL communication between the Access Manager server and the LDAP server (y/n)?"`
        queryUserYesNo SSL "$QMSG"

        #
        # get SSL specific info from user and set in conf file
        #
        KEYFILE=""
        KEYFILEDN=""
        KEYFILEPWD=""
        if [ "$SSL" = TRUE ]; then
        
          #
          # GET Key file location
          #
          while [ ! -n "$KEYFILE" ]
            do
              QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_LDAPSSLKEYFILE" "Enter the location of the LDAP SSL client key file:"`
              queryUser KEYFILE "$QMSG"  FALSE
            done

          #
          # GET Key file DN
          #
          QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_LDAPSSLDN" "Enter the SSL client certificate label (if required):"`
          queryUser KEYFILEDN "$QMSG" FALSE

          #
          # GET Key file password
          #
          while [ ! -n "$KEYFILEPWD" ]
           do
            QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_LDAPKEYFILEPWD" "Enter the LDAP SSL client key file password:"`
            queryUser KEYFILEPWD "$QMSG"  TRUE
          done

          QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_LDAPSERVERSSLPORT" "Enter the LDAP server SSL port number:"`
          queryUser LDAPSSLPORT "$QMSG" FALSE
                  
          ################  NOTE ######################
          # PDWeb_config calls a utility called ivrgy_tool 
          # that appears to do a bind to make sure all is working with LDAP
          # Add this later when you know how to make this work (packaging wise)          

          CONTINUE=TRUE

         else
           CONTINUE=TRUE
	   # reset LDAPPORT to its orginal value in case the user
	   # changed their mind from chosing SSL to Non-SSL
	   # Note: LDAPSSLPORT should be used for SSL port
           LDAPPORT=$TMP_LDAPPORT
      fi

    done
}
##############################################################################
# ldapCheckSSL
#
# assume LDAPADMINUSER is already set
# assume LDAPADMINUSERPWD is already set
##############################################################################
ldapCheckSSL()
{
    if [ -z "$SSL" ]; then
        $PDRDAMSG pdwslshmsg.cat "$MSG_SSL_NOTDEFINED" "ERROR: SSL not defined."
        return 1
    fi

    if [ "$SSL" = "TRUE" ]; then
        echo
        # check that LDAP SSL port number is set
        if [ -z "$LDAPSSLPORT" ]; then
            ivgmsg pdwslshmsg.cat "$MSG_LDAPSSLPORT_NOTDEFINED" "ERROR: LDAPSSLPORT not set."
            return 1
         fi

        # check that the location of LDAP SSL client key file is set
        if [ -z "$KEYFILE" ]; then
            $PDRDAMSG pdwslshmsg.cat "$MSG_KEYFILE_NOTDEFINED" "ERROR: KEYFILE not set."
            return 1
        fi
        # check that the SSL client certificate label is set
        if [ -z "$KEYFILEDN" ]; then
            $PDRDAMSG pdwslshmsg.cat "$MSG_KEYFILEDN_NOTDEFINED" "ERROR: KEYFILEDN not set."
            return 1
        fi
        # check that LDAP SSL client key file password is set
        if [ -z "$KEYFILEPWD" ]; then
            $PDRDAMSG pdwslshmsg.cat "$MSG_KEYFILEPWD_NOTDEFINED" "ERROR: KEYFILEPWD is not set."
            return 1
         fi
          ################  NOTE ######################
          # PDWeb_config calls a utility called ivrgy_tool 
          # that appears to do a bind to make sure all is working with LDAP
          # Add this later when you know how to make this work (packaging wise)   
    fi
  return 0
}

##############################################################################
# pdCheckAdmin()
#
##############################################################################
pdCheckAdmin()
{
   # check that ADMINUSER and ADMINUSERPWD are set and not NULL

   EXITERROR=0

   if [ -z "$ADMINUSER" ]; then
      $IVBIN$PDRDAMSG pdwslshmsg.cat "$MSG_PDADMINUSER_NOTDEFINED" "ERROR: PDADMINUSER not set."
       EXITERROR=1
   fi

   if [ -z "$ADMINPASSWORD" ]; then
      $PDRDAMSG pdwslshmsg.cat "$MSG_PDADMINPWD_NOTDEFINED" "ERROR: PDADMINPWD not set."
      EXITERROR=1
   fi

    return $EXITERROR
}


##############################################################################
#
# gethostname()
#
# This function prompts the user for full qualified hostname
#
##############################################################################
gethostname()
{
    #
    # ask for the Full Qualified host name
    #

   CONTINUE=FALSE
   # loop till it works
   while [ "$CONTINUE" = FALSE ]
   do
     CURRENTHOSTNAME="`hostname`"
     QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_GETHOSTNAME" "Enter the complete hostname of this machine"`
     queryUser CURRENTHOSTNAME "$QMSG" FALSE

     if [ -n "$CURRENTHOSTNAME" ]
       then 
           CONTINUE=TRUE
     fi
   done
}

##############################################################################
#
# wteGetPort()
#
# This function prompts the user WTE Port
#
##############################################################################
wteGetPort()
{
    #
    # ask for the Port Number
    #

   CONTINUE=FALSE
   # loop till it works
   while [ "$CONTINUE" = FALSE ]
   do
     WTEPORT="80"
     QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_GETWTEPORT" "Enter the port for Web Traffic Express [80]:"`
     queryUser WTEPORT "$QMSG" FALSE
     if [ -n "$WTEPORT" ]
       then 
               CONTINUE=TRUE
     fi
   done
}

   
##############################################################################
#
# wteCheckPort()
#
# This function checks to see if the WTE port was specified
#
##############################################################################
wteCheckPort()
{
    #
    # Check the WTE Port
    #

   if [ -z "$WTEPORT" ]; then
      $PDRDAMSG pdwslshmsg.cat "$MSG_WTEPORT_NOTDEFINED" "ERROR: WTEPORT not set."
      return 1
   fi
}

##############################################################################
#
# checkForUnconfig()
#
# This function makes sure that the hostname is correct
# and the the PD userid and PD password have been set
#
##############################################################################
checkForUnconfig()
{
    #
    # Check the WTE Port
    #
    RETURNCODE=0
   if [ "$HOSTNAMEINVALID" = "YES" ] 
    then
       $PDRDAMSG pdwslshmsg.cat "$MSG_INVALID_HOSTNAME" "ERROR: The hostname is invalid." 
       echo $CURRENTHOSTNAME
       RETURNCODE=1
   fi

   if [ "$WESENV" = "NO" ]
     then
      pdCheckAdmin
      RETURNCODE=$?  
   fi

   return $RETURNCODE
}


##############################################################################
#
# getAdminAndPassword()
#
# This function prompts the user for the ldap admin user and password
#
##############################################################################
getAdminAndPassword()
{
   while [ -z "$ADMINUSER" ]
   do
	#put some default here (is there something that is typical?)
	ADMINUSER="sec_master"
      QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_PDADMIN" "Enter the Access Manager Admin User ID [sec_master]:"`

     	queryUser ADMINUSER  "$QMSG" FALSE
   done

   while [ -z "$ADMINPASSWORD" ]
   do
     QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_PDPASSWORD" "Enter the Access Manager Admin Password:"`
     queryUser ADMINPASSWORD "$QMSG" TRUE
   done

}


##############################################################################
#
# getPD_or_Wes_info()
#
# This function prompts the user for the ldap admin user and password
#
##############################################################################
getPD_or_Wes_info()
{
   
        USEPD=YES
        QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_USEPD" "Are you using Access Manager (y/n)?"`
        queryUserYesNo USEPD "$QMSG"  
}

##############################################################################
#
# addParamToGeneralConf()
#
#	Adds a configuration item to the ibmwesas.conf config file
#       This method assumes that not parameters may have multiple definitions
#
#	$1 - Parameter name (key)
#	$2 - Parameter value (value)
#
##############################################################################
addParamToGeneralConf()
{
   found=`$PDRDACONF -g -f $GENERALCONF -l -P $1`
   if [ -z "$found" ]; then
      $PDRDACONF -g -f $GENERALCONF -a -P $1 $2
   else
      $PDRDACONF -g -f $GENERALCONF -m -P $1 $2
   fi
}


##############################################################################
#
# addParamToWTEConf()
#
#	Adds a configuration item to the ibmproxy.conf config file
#       This method assumes that not parameters may have multiple definitions
#
#     $1 - config file
#	$2 - Parameter name (key)
#	$3 - Parameter value (value)
#
##############################################################################
addParamToWTEConf()
{
   
   found=`$PDRDACONF -g -f $1 -l -P $2`
   if [ -z "$found" ]; then
      $PDRDACONF -g -f $1 -a -P $2 $3
   else
      $PDRDACONF -g -f $1 -m -P $2 $3
   fi
}


##############################################################################
#
# configureObjectSpace()
#
#       Adds a configuration item to the ibmwesas.conf config file
#       This method assumes that no parameters may have multiple definitions
#
##############################################################################
configureObjectSpace() 
{
   QUERYCOMMAND="http://$CURRENTHOSTNAME/cgi-bin/query_contents?dirlist=/"
   SERVERPORT=`cat $IBMPROXYCONF | awk '{if ($1=="Port") {print $2} }'`

if [ "$USEPD" = "TRUE" ]
 then
   
   GLOBALDEF=`$PDRDACONF -o -f $OSDEFCONF -l -G`
   if [ -z "$GLOBALDEF" ]; then
      $PDRDACONF -o -f $OSDEFCONF -a -G -P update_objectspace yes
      $PDRDACONF -o -f $OSDEFCONF -a -G -P update_admin_userid $ADMINUSER 
      $PDRDACONF -o -f $OSDEFCONF -a -G -P update_admin_password $ADMINPASSWORD
   else 
      UPOBJSPACE=`$PDRDACONF -o -f $OSDEFCONF -l -G | grep update_objectspace`
      UPADMINUSERID=`$PDRDACONF -o -f $OSDEFCONF -l -G | grep update_admin_userid`
      UPADMINPSSWD=`$PDRDACONF -o -f $OSDEFCONF -l -G | grep update_admin_password`
      [ -z "$UPOBJSPACE" ] && $PDRDACONF -o -f $OSDEFCONF -a -G -P update_objectspace yes
      [ -z "$UPADMINUSERID" ] && $PDRDACONF -o -f $OSDEFCONF -a -G -P update_admin_userid $ADMINUSER 
      [ -z "$UPADMINPSSWD" ] && $PDRDACONF -o -f $OSDEFCONF -a -G -P update_admin_password $ADMINPASSWORD
   fi

fi
#end of if [ "$USEPD" = "TRUE" ]

   LOCALDEF=`$PDRDACONF -o -f $OSDEFCONF -l -L`
   if [ -z "$LOCALDEF" ]; then
      $PDRDACONF -o -f $OSDEFCONF -a -L $BRANCH/$CURRENTHOSTNAME
   else 
      $PDRDACONF -o -f $OSDEFCONF -m -L $LOCALDEF -P branch $BRANCH/$CURRENTHOSTNAME
   fi
   
   
   if [ "$SERVERPORT" != "80" ];then
      QUERYCOMMAND="http://$CURRENTHOSTNAME:$SERVERPORT/cgi-bin/query_contents?dirlist=/"
   fi

   TEST=`$PDRDACONF -o -f $OSDEFCONF -l -L $BRANCH/$CURRENTHOSTNAME -P domains`
   if [ -n "$TEST" ]; then
      $PDRDACONF -o -f $OSDEFCONF -d -L $BRANCH/$CURRENTHOSTNAME -P domains
   fi

   $PDRDACONF -o -f $OSDEFCONF -a -L $BRANCH/$CURRENTHOSTNAME -P domains $CURRENTHOSTNAME localhost 


if [ "$USEPD" = "TRUE" ]
 then
   
   TEST=`$PDRDACONF -o -f $OSDEFCONF -l -L $BRANCH/$CURRENTHOSTNAME -P query_command`
   if [ -n "$TEST" ]; then
      $PDRDACONF -o -f $OSDEFCONF -d -L $BRANCH/$CURRENTHOSTNAME -P query_command
   fi
   $PDRDACONF -o -f $OSDEFCONF -a -L $BRANCH/$CURRENTHOSTNAME -P query_command "$QUERYCOMMAND"



   #******************************************
   #Add entries for /Docs and /icons junction for WTE error ages
   #******************************************
   if [ "$SERVERPORT" != "80" ];then
        QUERYCOMMAND="http://$CURRENTHOSTNAME:$SERVERPORT/cgi-bin/query_contents?dirlist=/Docs"
   else
        QUERYCOMMAND="http://$CURRENTHOSTNAME/cgi-bin/query_contents?dirlist=/Docs"
   fi

   TEST=`$PDRDACONF -o -f $OSDEFCONF -l -J $BRANCH/$CURRENTHOSTNAME:/Docs -P query_command`
   if [ -z "$TEST" ]; then
      $PDRDACONF -o -f $OSDEFCONF -a -J $BRANCH/$CURRENTHOSTNAME:/Docs -P query_command "$QUERYCOMMAND"
   else
      $PDRDACONF -o -f $OSDEFCONF -m -J $BRANCH/$CURRENTHOSTNAME:/Docs -P query_command "$QUERYCOMMAND"
   fi

if [ $WTE_VER -eq 3 ]
  then
    ICONSDIR=icons
 else
    ICONSDIR=cpicons
fi

   if [ "$SERVERPORT" != "80" ];then
       QUERYCOMMAND="http://$CURRENTHOSTNAME:$SERVERPORT/cgi-bin/query_contents?dirlist=/$ICONSDIR"
   else
       QUERYCOMMAND="http://$CURRENTHOSTNAME/cgi-bin/query_contents?dirlist=/$ICONSDIR"
   fi

   TEST=`$PDRDACONF -o -f $OSDEFCONF -l -J $BRANCH/$CURRENTHOSTNAME:/$ICONSDIR -P query_command`
   if [ -z "$TEST" ]; then
      $PDRDACONF -o -f $OSDEFCONF -a -J $BRANCH/$CURRENTHOSTNAME:/$ICONSDIR -P query_command "$QUERYCOMMAND"
   else
      $PDRDACONF -o -f $OSDEFCONF -m -J $BRANCH/$CURRENTHOSTNAME:/$ICONSDIR -P query_command "$QUERYCOMMAND"
   fi
fi
#end of if [ "$USEPD" = "TRUE" ]

}


##############################################################################
#
# configureWTE()
#
#       Adds a configuration item to the ibmwesas.conf config file
#       This method assumes that no parameters may have multiple definitions
#
#       $1   Ibmproxy.conf file to update
#       $2   [YES or NO ]Indicates if its okay for the file to already be configured.
##############################################################################
configureWTE()
{

   PASSEDIN_PROXYCONF=$1
   IS_ALREADY_CONFIG_OKAY=$2
   if [ "$IS_ALREADY_CONFIG_OKAY" = "" ]
     then
      IS_ALREADY_CONFIG_OKAY=NO
   fi

   # **************************************
   # Add Plugin Directives
   # **************************************
   SERVERINIT="ServerInit $PLUGINNAME:WTESeal_Init $GENERALCONF"
   PREEXIT="PreExit $PLUGINNAME:WTESeal_PreExit"
   AUTHORIZATION="Authorization * $PLUGINNAME:WTESeal_Authorize"
   SERVERTERM="ServerTerm   $PLUGINNAME:WTESeal_Term"
   TRANSMOGRIFIER="Transmogrifier  $PLUGINNAME:WTESeal_TransOpen:WTESeal_TransWrite:WTESeal_TransClose:WTESeal_TransError"
   TRANSMOGRIFIEDWARNING="TransmogrifiedWarning    NO"

   #check to make sure it hasn't been installed
   SERVERINITLINE=`cat $PASSEDIN_PROXYCONF | awk '{if ($1=="ServerInit" && $2=="'$PLUGINNAME':WTESeal_Init" && $3=="'$GENERALCONF'") {print $0; found=1} }'`
   PREEXITLINE=`cat $PASSEDIN_PROXYCONF | awk '{if ($1=="PREEXIT" && $2=="'$PLUGINNAME':WTESeal_PreExit") {print $0} }'`
   AUTHORIZATIONLINE=`cat $PASSEDIN_PROXYCONF | awk '{if ($1=="AUTHORIZATION" && $2=="'$PLUGINNAME':WTESeal_Authorize") {print $0} }'`
   SERVERTERMLINE=`cat $PASSEDIN_PROXYCONF | awk '{if ($1=="Error" && $2=="'$PLUGINNAME':WTESeal_Term") {print $0} }'`
   TRANSMOGRIFIERLINE=`cat $PASSEDIN_PROXYCONF | awk '{if ($1=="ServerTerm" && $2=="'$PLUGINNAME':WTESeal_TransOpen:WTESeal_TransWrite:WTESeal_TransClose:WTESeal_TransError") {print $0} }'`

   # If any of the plugin components exist, then we will have a problem
   if [ -n "$SERVERINITLINE" -o -n "$PREEXITLINE" -o -n "$AUTHORIZATIONLINE" -o -n "$SERVERTERMLINE" -o -n "$TRANSMOGRIFIERLINE" ] ; then
       if [ "$IS_ALREADY_CONFIG_OKAY" = "NO" ]
          then
             echo "Error, Plugin is already installed"
             chmod 644 $PASSEDIN_PROXYCONF
             exit 1
       else
             return 0
       fi
   fi


   chmod +w $PASSEDIN_PROXYCONF
   # Get the server root so that you know where to look for cgi-bin
   SERVERROOT=`cat $IBMPROXYCONF | awk '{if ($1=="ServerRoot") {print $2} }'`

   

   # ************************************
   # Create cgi-bin under SERVERROOT
   # if it does not exist.
   # ************************************  
   ls $SERVERROOT/cgi-bin > /dev/null 2>&1
   retval=$?
   if [ $retval -ne 0 ]; then
       mkdir $SERVERROOT/cgi-bin
   fi


   # ************************************
   # Make sure that ibmproxy runs as root
   # and that the GroupID is system
   # ************************************
   case "$OSTYPE" in
      SunOS )
      USERID=root
      GROUPID=other
         ;;
      AIX )
        USERID=root
        GROUPID=system
         ;;
      Linux )
        USERID=root
        GROUPID=root
         ;;
  esac

   cat $PASSEDIN_PROXYCONF | awk '{
					if ($1=="UserId" && $2!="'$USERID'") {
					    print $1" '$USERID'";
					} 
					else if ($1=="GroupId" && $2!="'$GROUPID'") {
					    print $1" '$GROUPID'";
					}
					else {
					    print $0
					}
				      }' > $PASSEDIN_PROXYCONF.temp

   echo y | cp $PASSEDIN_PROXYCONF.temp $PASSEDIN_PROXYCONF >> $ERRORLOG 2>&1

#   # **************************************
#   # Add the NoLog Statement 
#   # if it is not already there.
#   # **************************************
#
#   NOLOG=`cat $PASSEDIN_PROXYCONF | awk '{
#					if ($1=="NoLog" && $2=="\*") {
#					    print $0
#					} 
#				   }'` 
#  if [ -z "$NOLOG" ]; then
#     # The proper NoLog statement was not found.
#       # Look for another NoLog statement so that we place
#       # Our statement in a "smart" location
#       NOLOG=`cat $PASSEDIN_PROXYCONF | awk '{if ($1=="NoLog" && found==0) {print $0; found=1} }'`
#       if [ -n "$NOLOG" ]; then
#	    # Put the NoLog line near other Exec lines
#	    cat $PASSEDIN_PROXYCONF | awk '{
#				    if ($1=="NoLog" && found==0) {
#					print "NoLog *"; 
#					print $0; found = 1
#				    }
#				    else {
#					print $0; 
#				    }
#				 }' > $PASSEDIN_PROXYCONF.temp
#            echo y | cp $PASSEDIN_PROXYCONF.temp $PASSEDIN_PROXYCONF >> $ERRORLOG 2>&1
#
#       else
#	    # If no other Exec lines exist, put it at the end of the file
#	    echo "NoLog *" >> $PASSEDIN_PROXYCONF
#       fi
#   fi



   # **************************************
   # Add the Exec Statement for cgi-bin
   # if it is not already there.
   # **************************************
   EXECLINE=`cat $PASSEDIN_PROXYCONF | awk '{
					if ($1=="Exec" && $2=="/cgi-bin/*" && $3=="'$SERVERROOT'/cgi-bin/*") {
					    print $0
					} 
				   }'` 
 
   if [ -z "$EXECLINE" ]; then
       # The proper Exec statement was not found.
       # Look for another Exec statment so that we place
       # Our statement in a "smart" location
       EXECLINE=`cat $PASSEDIN_PROXYCONF | awk '{if ($1=="Exec" && found==0) {print $0; found=1} }'`
       if [ -n "$EXECLINE" ]; then
	    # Put the Exec line near other Exec lines
	    cat $PASSEDIN_PROXYCONF | awk '{
				    if ($1=="Exec" && found==0) {
					print "Exec /cgi-bin/* '$SERVERROOT'/cgi-bin/*"; 
					print $0; found = 1
				    }
				    else {
					print $0; 
				    }
				 }' > $PASSEDIN_PROXYCONF.temp
             echo y | cp $PASSEDIN_PROXYCONF.temp $PASSEDIN_PROXYCONF >> $ERRORLOG 2>&1

       else
	    # If no other Exec lines exist, put it at the end of the file
	    echo "Exec /cgi-bin/* $SERVERROOT/cgi-bin/*" >> $PASSEDIN_PROXYCONF
       fi
   fi



 #The awk on Sun is broken.  It will not allow the use of ~
 if [ "$OSTYPE" = "SunOS" ]
  then
    if [ -z "$SERVERINITLINE" ]
      then
         {
   	     echo "$SERVERINIT"
	     echo "$PREEXIT"
	     echo "$AUTHORIZATION"
	     echo "$SERVERTERM"
	     echo "$TRANSMOGRIFIER"
         } >> $PASSEDIN_PROXYCONF

      addParamToWTEConf $PASSEDIN_PROXYCONF TransmogrifiedWarning "NO"
    fi
 else
     # Find a "smart" place to put the plugin directives if you can
   APILINE=`cat $PASSEDIN_PROXYCONF | awk '{if ($2=="API" && $3~"directives" && found==0) {print $0; found=1} }'`
   if [ -z "$APILINE" ]; then
       # Just put it at the end of the file because a "smart location" was not found
       {
	    echo "$SERVERINIT"
	    echo "$PREEXIT"
	    echo "$AUTHORIZATION"
	    echo "$SERVERTERM"
	    echo "$TRANSMOGRIFIER"
       } >> $PASSEDIN_PROXYCONF
      addParamToWTEConf $PASSEDIN_PROXYCONF TransmogrifiedWarning "NO"
   else
       # Found a smart location, so insert new lines at this location
       cat $PASSEDIN_PROXYCONF | awk '{
				if ($2=="API" && $3~"directives" && found==0) {
				    found = 1;
				    print $0
				}
				else if(added==0 && found==1 && $1!~"#") {
				    print "ServerInit '$PLUGINNAME':WTESeal_Init '$GENERALCONF'";
				    print "PreExit '$PLUGINNAME':WTESeal_PreExit";
				    print "Authorization \* '$PLUGINNAME':WTESeal_Authorize";
				    print "ServerTerm   '$PLUGINNAME':WTESeal_Term";
				    print "Transmogrifier  '$PLUGINNAME':WTESeal_TransOpen:WTESeal_TransWrite:WTESeal_TransClose:WTESeal_TransError";
				    added=1
				    print $0;
				}
				else {
				    print $0; 
				}
			    }' > $PASSEDIN_PROXYCONF.temp
        echo y | cp $PASSEDIN_PROXYCONF.temp $PASSEDIN_PROXYCONF >> $ERRORLOG 2>&1
        addParamToWTEConf $PASSEDIN_PROXYCONF TransmogrifiedWarning "NO"
   fi
fi
#end of  if [ "$OSTYPE" = "SunOS" ]


   PROTECTIONLINE=`cat $PASSEDIN_PROXYCONF | awk '{if ($1=="Protection" && found==0) {print $0; found=1} }'`
   if [ -z "$PROTECTIONLINE" ]; then
       # Just put it at the end of the file because a "smart location" was not found
       {
	    echo "Protection PROXY-PROT {"
	    echo "ServerId ESproxy"
	    echo "Mask All@(*)"
	    echo "AuthType Basic"
	    echo "}"
	    echo "Protect * PROXY-PROT"
          echo " "
       } >> $PASSEDIN_PROXYCONF
   else
       # Found a smart location, so insert new lines at this location
       cat $PASSEDIN_PROXYCONF | awk '{
				if ($1=="Protection" && found==0) {
				    found = 1;
				    print "Protection PROXY-PROT {";
				    print "ServerId ESproxy";
				    print "Mask All@(*)";
				    print "AuthType Basic";
				    print "}";  			          
				    print "Protect * PROXY-PROT\n";
                            print " ";
				    print $0
				}
				else {
				    print $0; 
				}
			     }' > $PASSEDIN_PROXYCONF.temp
          echo y | cp $PASSEDIN_PROXYCONF.temp $PASSEDIN_PROXYCONF >> $ERRORLOG 2>&1
    fi


if [ "$UPDATEWTEPORT" = "TRUE" ]
  then
   # **************************************
   # Update the WTE Port
   # **************************************

    cat $PASSEDIN_PROXYCONF | awk '{
					if ($1=="Port") {
					    print "Port '$WTEPORT'"
					} 
				    else {
					print $0; 
				    }

				   }' > $PASSEDIN_PROXYCONF.temp
    echo y | cp $PASSEDIN_PROXYCONF.temp $PASSEDIN_PROXYCONF >> $ERRORLOG 2>&1

fi


  chmod 644 $PASSEDIN_PROXYCONF

}

##############################################################################
#
# get_wsl_rte_environment()
#
#       Set the environment variables for Access Manager Plug-in for Edge Server
#
##############################################################################
get_wsl_rte_environment()
{
  case "$OSTYPE" in
   Linux )
         echo "export LD_LIBRARY_PATH=/lib:/usr/lib:/opt/PolicyDirector/lib:/usr/local/ibm/gsk5/lib:$WSLLIBDIR:/usr/ldap/lib:$LD_LIBRARY_PATH"
         echo "export LIBPATH=\$LD_LIBRARY_PATH"

      ;;
   SunOS )
         echo "export LD_LIBRARY_PATH=/usr/lib:/opt/PolicyDirector/lib:$WSLLIBDIR:$LD_LIBRARY_PATH"
         echo "export LIBPATH=\$LD_LIBRARY_PATH"

      ;;
   AIX )
         echo "export LD_LIBRARY_PATH=/usr/lib:/opt/PolicyDirector/lib:$WSLLIBDIR:$LD_LIBRARY_PATH"
         echo "export LIBPATH=\$LD_LIBRARY_PATH"
      ;;
   esac

   echo "export PATH=$PATH:/usr/bin:/usr/sbin"
   echo "export NLSPATH=/opt/pdweb-lite/nls/msg/%L/%N:$NLSPATH"
   echo "export TISDIR=/opt/pdweb-lite/nls"

}

##############################################################################
#
# getJavaDir()
#
# This function prompts the user for the java directory
#
##############################################################################
getJavaDir()
{
    #
    # ask for the Java dir
    #

      case "$OSTYPE" in
       Linux )
         JAVADIR="/opt/IBMJava2-13/jre"
         ;;
       SunOS )
          JAVADIR="/opt/j2sdk1_3_0"
         ;;
       AIX )
          JAVADIR="/usr/java130/jre"
        ;;
       esac


   CONTINUE=TRUE

   if [ -n "$JAVADIR" ]; then 
        checkJavaDir QUIETON 
        rc=$?

        if [ $rc -eq 0 ]
          then            
            CONTINUE=FALSE
        fi
   fi

   # loop till it works
   while [ "$CONTINUE" = TRUE ]
   do
      QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_GETJAVADIR" "Enter the location of Java JRE/JDK 1.3 "`
      MSG="$QMSG [$JAVADIR]:"

      queryUser JAVADIR "$MSG" FALSE

      
     if [ -n "$JAVADIR" ]; then 
        checkJavaDir 
        rc=$?

        if [ $rc -eq 0 ]
          then            
            CONTINUE=FALSE
        fi
     fi
   done
}

##############################################################################
#
# checkJavaDir()
#    $1 if anything is passed into $1 then messages will not be displayed.
#
# This function checks to see if the java directory is fine
#
# 
##############################################################################
checkJavaDir()
{
  [ -z "$JAVADIR" ] &&   $PDRDAMSG pdwslshmsg.cat "$MSG_JAVADIR_EMPTY" "Error: The Java Directory was not specified" 

  [ -z "$JAVADIR" ] && return 1

  QUIET=OFF
  [ ! -z "$1" ] && QUIET=ON
  
  JDIR=$JAVADIR
  JRC=0

   case "$OSTYPE" in
       Linux )
         LIBJAVA="libjava.so"
         RTJAR="rt.jar"
         LIBJVM="libjvm.so"
         JAVACOMMAND="java"
         ;;
       SunOS )
         LIBJAVA="libjava.so"
         RTJAR="rt.jar"
         LIBJVM="libjvm.so"
         JAVACOMMAND="java"
         ;;
       AIX )
         LIBJAVA="libjava.a"
         RTJAR="rt.jar"
         LIBJVM="libjvm.a"
         JAVACOMMAND="java"
        ;;
       esac


  TEMPVAR=`find $JDIR -name $LIBJAVA 2>/dev/null | head -01`
  if [ -n "$TEMPVAR" ]
     then
        JAVALIB=`dirname $TEMPVAR`
  else
    JRC=1
    [ "$QUIET" = "OFF" ] && {
    QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_JAVALIB_ERROR" "Error: Unable to locate " `
    echo ${QMSG} $LIBJAVA
    }
  fi


  if [ "$OSTYPE" != "SunOS" ]
    then
      TEMPVAR=`find $JDIR -name $LIBJVM 2>/dev/null | head -01`
      if [ -n "$TEMPVAR" ]
     then
        JAVALIB=$JAVALIB:`dirname $TEMPVAR`
  else
    JRC=1
    [ "$QUIET" = "OFF" ] && {
    QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_JAVAJVM_ERROR" "Error: Unable to locate "`
    echo ${QMSG} $LIBJVM
    }
  fi


  fi

  TEMPVAR=`find $JDIR -name $RTJAR 2>/dev/null | head -01`
  if [ -n "$TEMPVAR" ]
     then
        JAVAJAR=`dirname $TEMPVAR`
  else
    JRC=1
    [ "$QUIET" = "OFF" ] && {
    QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_JAVAJAR_ERROR" "Error: Unable to locate "`
    echo ${QMSG} $RTJAR
    }

  fi

  TEMPVAR=`find $JDIR -name $JAVACOMMAND 2>/dev/null | grep "bin/$JAVACOMMAND" | head -01`
  if [ -n "$TEMPVAR" ]
     then
        JAVABIN=`dirname $TEMPVAR`
  else
    JRC=1
    [ "$QUIET" = "OFF" ] && {
    QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_JAVABIN_ERROR" "Error: Unable to locate the java command."`
    echo ${QMSG}     
    }
  fi

  return $JRC
}

##############################################################################
#
# createWTE_startfile()
#
#       The Access Manager Plug-in for Edge Server requires environment variables
#       to be set when WTE is started.  This routine will create a
#       startup script to start ibmproxy with the correct environment variables
#
##############################################################################
createWTE_startfile()
{
   {
     echo "#!/bin/ksh"
     get_wsl_rte_environment
     echo 
     echo "#export AMPLUGINNLSOFF=YES"
     if [ "$OSTYPE" = "SunOS" ]
       then
         echo "#set AMPLUGINNLSOFF"
         echo "ulimit -n 1024"
     fi

     echo ibmproxy
   }> $STARTWTE
   chmod +x $STARTWTE
   [ ! -f $STARTWTELINK ] && ln -sf $STARTWTE $STARTWTELINK
}

##############################################################################
#
# createWTE_wesosm_file()
#
#       The wesosm utility requires environment variables to be set
#       This routine will create a startup script that will set the 
#       correct environment variables.
#
##############################################################################
createWTE_wesosm_file()
{
   {
     echo "#!/bin/ksh"
     get_wsl_rte_environment
     echo 
     echo $WESOSM "\$*"
     echo exit "\$?"
   }> $STARTWESOSM
   chmod +x $STARTWESOSM
}


##############################################################################
#
# createLTPA_cookie_file()
#
#       The routine will create the ltpa cookie file
#
##############################################################################
createLTPA_cookie_file()
{
   echo " " 
   $PDRDAMSG pdwslshmsg.cat "$MSG_COOKIECREATE" "Creating LTPA cookie key file" 

   addParamToGeneralConf LTPA_Cookie_Enabled "no"

   TMPSCRIPT=$WSLBINDIR/createcookiekey.sh

   [ -f $LTPACOOKIEFILE ] && rm -f $LTPACOOKIEFILE

   COOKIEPASS=x9b9cl3kc87bj
   {
     get_wsl_rte_environment
     echo java com.ibm.wte.sso.TestSSO $LTPACOOKIEFILE $COOKIEPASS 
     echo if [ ! -f $LTPACOOKIEFILE ]
     echo  then
     echo     exit 1
     echo else
     echo     exit 0
     echo fi
   }> $TMPSCRIPT
   chmod 700 $TMPSCRIPT
   $TMPSCRIPT >> $ERRORLOG 2>&1
   rc=$?
   if [ $rc -eq 0 ]
     then
      echo " "
      $PDRDAMSG pdwslshmsg.cat "$MSG_COOKIECREATE_SUCCESS" "LTPA cookie key file created successfully" 

       addParamToGeneralConf LTPA_Cookie_Enabled            "Yes"
       addParamToGeneralConf LTPA_Cookie_Keyfile    	      "$LTPACOOKIEFILE"
       addParamToGeneralConf LTPA_Cookie_Keyfile_Password   "$COOKIEPASS"
       addParamToGeneralConf LTPA_Cookie_TTL                "30"
       addParamToGeneralConf LTPA_Cookie_Contains_Password  "No"
   else
      $PDRDAMSG pdwslshmsg.cat "$MSG_COOKIECREATE_ERROR" "Error: Unable to create LTPA cookie key file" 
   fi
#  [ -f $TMPSCRIPT ] && rm -f $TMPSCRIPT
   return $rc
}

#***********************************************************
# START
#***********************************************************

# Get operating system type
OSTYPE=`uname -s`

# $01
#*************************************
#NEW variables for multiple registries
#*************************************
LDAPTYPE=1
DOMINOTYPE=2
ACTIVEDIRECTORYTYPE=3 #not supported on Unix platforms

REGISTRYNAME=LDAP
REGISTRYTYPE=$LDAPTYPE



# Dir of utils used by this script

PDRDACONFDIR="pdrdaconf"
#**************************************
#                Data                 #
#**************************************

initialize

# TO DO: Set the following variables to correct values when known

# WTE Server Data
getWTEPackageInfo
IBMPROXYCONF="$WTECONFDIR/ibmproxy.conf"
SERVERROOT=""
SERVERPORT="80"

BACKUPEXTENSION=".wsl"
# Plugin Data
BRANCH="/ESproxy"  
WSLSERVERNAME="ESproxy"
DEFAULTACL=default-ESproxy
DEFAULTUNAUTHACL=default-unauth-esp
DEFAULTANYOTHERACL=default-anyother-esp

GENERALCONF="$WSLCONFDIR/ibmwesas.conf"
WESCONF="$WSLCONFDIR/ibmepsas.conf.template"
OSDEFCONF="$WSLCONFDIR/osdef.conf"
USERMAPCONF="$WSLCONFDIR/usermap.conf"
PDRDACONF="$WSLBINDIR/wslconfig"
PDRDAMSG="$WSLBINDIR/pdwslgetmsg.sh"
WESOSM="$WSLBINDIR/wesosm"
ERRORLOG="$WSLCONFDIR/config.log"
[ -f $ERRORLOG ] && rm -f $ERRORLOG

JAVABIN=
JAVALIB=

PLUGINLIBNAME="wesauth.so"
PLUGINNAME="$WSLLIBDIR/$PLUGINLIBNAME"
POLICYDIRSSLFILE="$WSLCONFDIR/wslpdazn.conf"
LTPACOOKIEFILE="$WSLCONFDIR/wslLTPAcookie.key"
WEBSEALFAILOVERKEYFILE="$WSLCONFDIR/cdsso.keys"
STARTWTE="$WSLBINDIR/wslstartwte"
STARTWTELINK="/usr/bin/"`basename $STARTWTE`
STARTWESOSM="/usr/bin/wesosm"

# Access Manager Data
QUERYCONTENTS="$QUERYCONTENTSDIR/query_contents.sh"

# PD Server Admin User Id & Password
ADMINUSER=""
ADMINPASSWORD=""

# LDAP information
LDAPHOST=""
LDAPPORT=389
LDAPADMINUSER="cn=root"
LDAPADMINUSERPWD=""
SSL=No
KEYFILE=""
KEYFILEPWD=""
KEYFILEDN=""

SILENT=FALSE
USEPD=TRUE
UPDATEWTEPORT=TRUE
WTEPORTCMDLINE=FALSE
COPYWESCONF=FALSE
WTE_VER=4
# Make sure running as root
checkRootId


#**************************************
#   Get Command Line Options  	      #
#**************************************
LDAPUSAGE="[-d ldapAdmin] [-w ldapPwd] [-H ldapHost] [-P ldapPort]"
SSLUSAGE="[-Z TRUE|FALSE] [-F keyfile] [-N keyfileDN] [-K keyfilePwd]"
USAGE="usage: [-s TRUE|FALSE] [-I (Not Using Access Manager) ] [-X (Append WES Config File)] [-a AccessManagerAdminId] [-p AccessManagerAdminPwd] \n   [-h hostname ] [ -W WTE Port] \n   [ -u {unconfig} ] [ -j javadir  ] \n   $LDAPUSAGE \n   $SSLUSAGE"

while getopts :s:h:t:a:p:d:w:W:H:P:Z:j:uIX arguments
do
     case $arguments in
        s) SILENT=$OPTARG
          ;;
        a) ADMINUSER=$OPTARG
          ;;
        I) USEPD=FALSE
          ;;
        X) COPYWESCONF=TRUE
          ;;
        p) ADMINPASSWORD=$OPTARG
          ;;
        d) LDAPADMINUSER=$OPTARG
          ;;
        w) LDAPADMINUSERPWD=$OPTARG
          ;;
        h) CURRENTHOSTNAME=$OPTARG
          ;;
	  H) LDAPHOST=$OPTARG
	    ;;
	  P) LDAPPORT=$OPTARG
	    ;;
	  Z) SSL=$OPTARG
	    ;;
	  F) KEYFILE=$OPTARG
	    ;;
        N) KEYFILEDN=$OPTARG
	    ;;
	  K) KEYFILEPWD=$OPTARG
	    ;;
	  W) WTEPORT=$OPTARG
           WTEPORTCMDLINE=TRUE
	    ;;
	  j) JAVADIR=$OPTARG
	    ;;

	  u) UNCONFIG=YES
	    ;;

        \?) print "$OPTARG is not a valid switch."
            print "$USAGE" 
		exit 1;;
    esac
done

#if [ "$SILENT" = "FALSE" ]; then  
#   getPD_or_Wes_info
#fi

#Check to see if we need to update the WTEPort
if [ "$SILENT" = "TRUE" ]
 then  
   #IF THE WTEPORT COMMAND LINE OPTION WAS NOT SPECIFIED 
   #THEN DON'T UPDATE THE PORT
   if [ "$WTEPORTCMDLINE" = "FALSE" ]
    then
       UPDATEWTEPORT=FALSE
   fi

fi 




if [ "$USEPD" = "TRUE" ]
 then
    AUTHMETHOD="PolicyDir"
    WESENV=NO
else
    AUTHMETHOD="LDAP"
    WESENV=YES
    COPYWESCONF=TRUE
fi


# Get the hostname
if [ -z "$CURRENTHOSTNAME" ]
 then
   CURRENTHOSTNAME=`hostname`
fi

#make sure hostname was determined okay if not then prompt for it
HOSTNAMEINVALID=NO
if [ -z "$CURRENTHOSTNAME" ]
  then
   HOSTNAMEINVALID=YES
fi

SVRSSLHOSTNAME=`echo $CURRENTHOSTNAME | cut -d\. -f1`

#*************************************
#*Check to see if this is an unconfig
#*************************************
if [ "$UNCONFIG" = "YES" ]
  then
  #IF Silent mode make sure we have
  #the hostname, PD userid and PD password
  if [ "$SILENT" = "TRUE" ]
   then
      checkForUnconfig || exit 1
  fi

  CleanUp     

  exit 0
fi



#**************************************
#   Check for Installed Packages      #
#**************************************

getWTEPackageInfo
isPackageInstalled $WTEPACKAGE $WTEVERSION
rc=$?
if [ $rc -ne 0 ]; then
     #On sun check for another package
     if [ "$OSTYPE" = "SunOS" ]
        then
             isPackageInstalled $WTEPACKAGE2 $WTEVERSION
             rc=$?
             if [ $rc -ne 0 ]; then
                  QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_PACKAGE_NOT_INSTALLED" "ERROR: The following package is not installed: "`
                  echo ${QMSG} $WTEPACKAGE,$WTEPACKAGE2 $WTEVERSION
                  exitFailure
             fi
     else
       QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_PACKAGE_NOT_INSTALLED" "ERROR: The following package is not installed: "`
       echo ${QMSG} $WTEPACKAGE $WTEVERSION
       exitFailure
     fi
fi


if [ "$AUTHMETHOD" != "LDAP" ]; then

   getPDPackageInfo 
   isPackageInstalled $PDRTEPKGNAME $PDRTEVERSION
   rc=$?

   if [ $rc -ne 0 ]; then
       QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_PACKAGE_NOT_INSTALLED" "ERROR: The following package is not installed: "`
       echo ${QMSG} $PDRTEPKGNAME $PDRTEVERSION
      exitFailure
   fi

#**********************************
# Dont' check for LDAP so that IPlanet LDAP
# can be used.
#**********************************
#   getLDAPPackageInfo
#   isPackageInstalled $LDAPPKGNAME $LDAPVERSION
#   rc=$?
#   if [ $rc -ne 0 ]; then
#     #*********************************************************
#     #It is possible to have 2 different ldap packages on linux
#     #so lets check for the second one
#     #*********************************************************
#     if [ "$OSTYPE" = "Linux" ]
#       then
#         isPackageInstalled $LDAPPKGNAME2 $LDAPVERSION
#         rc2=$?
#         if [ $rc2 -ne 0 ]; then
#           if [ $rc -eq 1 ]; then
#             QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_PACKAGE_NOT_INSTALLED" "ERROR: The following package is not installed: "`
#             echo ${QMSG} $LDAPPKGNAME
#           else
#             QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_PACKAGE_VERSION_WRONG" "ERROR: The following package is the wrong version: "`
#             echo ${QMSG} $LDAPVERSION
#           fi

#             if [ $rc2 -eq 1 ]; then
#                 QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_PACKAGE_NOT_INSTALLED" "ERROR: The following package is not installed: "`
#                 echo ${QMSG} $LDAPPKGNAME2
#             else
#                QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_PACKAGE_VERSION_WRONG" "ERROR: The following package is the wrong version: "`
#                echo ${QMSG} $LDAPVERSION
#             fi

#             QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_LDAP_CHOICE_ERROR" "ERROR: One or more of the following packages must be installed :"`
#             echo ${QMSG} $LDAPPKGNAME $LDAPPKGNAME2

#             exitFailure
#         fi
#     else
#           if [ $rc -eq 1 ]; then
#             QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_PACKAGE_NOT_INSTALLED" "ERROR: The following package is not installed: "`
#             echo ${QMSG} $LDAPPKGNAME
#           else
#             QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_PACKAGE_VERSION_WRONG" "ERROR: The following package is the wrong version: "`
#             echo ${QMSG} $LDAPVERSION
#           fi

#           exitFailure
#     fi
#   fi

else
   getLDAPPackageInfo
#**********************************
# Dont' check for LDAP so that IPlanet LDAP
# can be used.
#**********************************
#   isPackageInstalled $LDAPPKGNAME $LDAPVERSION
#   rc=$?
#   if [ $rc -ne 0 ]; then
#     #*********************************************************
#     #It is possible to have 2 different ldap packages on linux
#     #*********************************************************
#     if [ "$OSTYPE" = "Linux" ]
#       then
#         isPackageInstalled $LDAPPKGNAME2 $LDAPVERSION
#         rc=$?
#         if [ $rc -ne 0 ]; then
#           exitFailure
#         fi
#     else
#       exitFailure
#     fi
#   fi
fi

# Either copy the conf files from templates or make
# a backup of the original configuration file
CONFFILESCOPIED=NO
backupcopyconffile WSL "$GENERALCONF"
backupcopyconffile WSL "$OSDEFCONF"
backupcopyconffile WSL "$USERMAPCONF"
backupcopyconffile WTE "$IBMPROXYCONF"
for conf_file in `find $WTEINSTALLDIR -type f -name ibmproxy.conf`
do
   backupcopyconffile WTE "$conf_file"
done
CONFFILESCOPIED=YES



#**************************************
#   Set the LDAP and PD Information  	      
#**************************************
if [ "$SILENT" = "FALSE" ]; then
   [ "$HOSTNAMEINVALID" = "YES" ] && gethostname
# $01   ldapGetHostPort
# $01   ldapGetAdmin
   wteGetPort
   if [ "$WESENV" = "NO" ]
     then
# $01        ldapGetSSL
        getAdminAndPassword
   fi

else
# $01   ldapCheckHostPort || exit 1
# $01   ldapCheckAdmin || exit 1
   if [ "$WTEPORTCMDLINE" = "TRUE" ]
     then
       wteCheckPort || exit 1
   fi

   if [ "$WESENV" = "NO" ]
     then
# $01       ldapCheckSSL || exit 1
       pdCheckAdmin || exit 1
   fi


   if [ "$HOSTNAMEINVALID" = "YES" ] 
    then
       $PDRDAMSG pdwslshmsg.cat "$MSG_INVALID_HOSTNAME" "ERROR: The hostname is invalid." 
       echo $CURRENTHOSTNAME
       exit 1
   fi

fi


# $01
#********************************************
#   Determine the registry type            
#   Either LDAP, Domino, or Active Directory
#********************************************
if [ "$WESENV" = "NO" ]
 then
   TMPREGFILE=registryinfo.$$
   echo "$PDRTEDIR/pdadmin admin show configuration" >> $ERRORLOG
   $PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" admin show configuration >> $TMPREGFILE 2>&1
   rc=$?
   if [ $rc -eq 0 ]
      then
        #********************************************
        #cat the output to the log file
        #********************************************
        cat $TMPREGFILE >> $ERRORLOG 2>&1

        #********************************************
        #Pick out the registry type
        #
        #The awk statement prints every thing 
        #except for the last word
        #********************************************
        REGISTRYNAME=`cat $TMPREGFILE | head -1 | awk '{for(i=1;i<=NF;i++)
                                                          {
                                                             if(i < NF)
                                                                 printf "%s",$i 
                                                             if(i < NF-1)
                                                                 printf " " 
                                                          }
                                                        }'`

        #********************************************
        #If Blank Reg name exit
        #********************************************
        if [ "$REGISTRYNAME" = "" ]      
          then
            [ -f $TMPREGFILE ] && rm -f $TMPREGFILE
            exitFailure 
        fi

        #********************************************
        #SET THE REGISTRY TYPE
        #********************************************
        REGISTRYTYPE=
        [ `echo $REGISTRYNAME | grep -ic ldap` -eq 1 ] && REGISTRYTYPE=$LDAPTYPE
	  [ `echo $REGISTRYNAME | grep -ic domino` -eq 1 ] && REGISTRYTYPE=$DOMINOTYPE
        #not supported on Unix   [ `echo $REGISTRYNAME | grep -ic active` -eq 1 ] && REGISTRYTYPE=$ACTIVEDIRECTORYTYPE 

        #********************************************
        #If Blank Reg type exit
        #********************************************
        if [ "$REGISTRYTYPE" = "" ]      
          then
            [ -f $TMPREGFILE ] && rm -f $TMPREGFILE
            exitFailure 
        fi
       
   else
      cat $TMPREGFILE
      cat $TMPREGFILE >> $ERRORLOG 2>&1
      [ -f $TMPREGFILE ] && rm -f $TMPREGFILE
      exitFailure 
   fi

   [ -f $TMPREGFILE ] && rm -f $TMPREGFILE

fi


if [ "$WESENV" = "NO" ]
  then

   #**************************************
   #   Register Plugin  	  	      
   #**************************************
   SVRSSLCFGOKAY=NO
   RANDOMPASSWORD=`$WSLBINDIR/random_pass`
   $PDRTEDIR/svrsslcfg -f "$POLICYDIRSSLFILE" -config -r 7140 -d "$WSLCONFDIR" -n "$WSLSERVERNAME/$SVRSSLHOSTNAME" -S "$RANDOMPASSWORD" -s local -A "$ADMINUSER" -P "$ADMINPASSWORD" -l yes
   rc=$?
   if [ $rc -eq 0 ]
     then
       SVRSSLCFGOKAY=YES
       addParamToGeneralConf PolicyDir_SSL_File "$POLICYDIRSSLFILE"
   else
      $PDRDAMSG pdwslshmsg.cat "$MSG_SVRSSLCFG_ERROR" "ERROR: The Access Manager svrsslcfg command failed.Please see the Access Manager Manual for troubleshooting." 
     exitFailure 
   fi
fi


#$01
if [ "$WESENV" = "NO" ]
  then
    #************************************************
    #Perform Registry Specific config
    #************************************************
    TMPINFOFILE=tempinfo.$$
    case "$REGISTRYTYPE" in
    $LDAPTYPE )
      #******************************************
      #Add our application's userid to the ldap security group
      #******************************************
      $PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" group modify SecurityGroup add $WSLSERVERNAME/$SVRSSLHOSTNAME >> $TMPINFOFILE 2>&1
      rc=$?
      if [ $rc -ne 0 ]
        then
           cat $TMPINFOFILE 
           cat $TMPINFOFILE >> $ERRORLOG 2>&1
           [ -f $TMPINFOFILE ] && rm -f $TMPINFOFILE
           exitFailure 
      fi

     [ -f $TMPINFOFILE ] && rm -f $TMPINFOFILE

     ;;
   esac

    #************************************************
    #Write the Registry type to the plugin config file
    #************************************************
    addParamToGeneralConf PolicyDir_User_Registry "$REGISTRYNAME"    
fi



#**************************************
#   Set LDAP values          	       #
#**************************************
# Save LDAP data in General Configuration File
if [ "$WESENV" = "NO" ]
  then
    #****************************************
    #Get the LDAP values from the svrsslcfg 
    #config file.
    #The sed statement replaces everything from the
    #beginning of the line to the first = with nothing
    #****************************************
   LDAPHOST=`$PDRDACONF -o -f $POLICYDIRSSLFILE -l -U:ldap -P host | sed "s/^[^=]*= //"`
   LDAPPORT=`$PDRDACONF -o -f $POLICYDIRSSLFILE -l -U:ldap -P port | sed "s/^[^=]*= //"`
   LDAPADMINUSER=`$PDRDACONF -o -f $POLICYDIRSSLFILE -l -U:ldap -P bind-dn | sed "s/^[^=]*= //"`
   LDAPADMINUSERPWD=`$PDRDACONF -o -f $POLICYDIRSSLFILE -l -U:ldap -P bind-pwd | sed "s/^[^=]*= //"`

   addParamToGeneralConf PolicyDir_LDAP_Host "$LDAPHOST"
   addParamToGeneralConf PolicyDir_LDAP_Port "$LDAPPORT"
   addParamToGeneralConf PolicyDir_LDAP_Admin_DN "$LDAPADMINUSER"
   addParamToGeneralConf PolicyDir_LDAP_Admin_Password "$LDAPADMINUSERPWD"

   #$01 don't need this now  if [ "$SSL" = "Yes" ]; then
   #$01 don't need this now     addParamToGeneralConf PolicyDir_SSL_Keyfile "$KEYFILE"
   #$01 don't need this now     addParamToGeneralConf PolicyDir_SSL_Keyfile_DN "$KEYFILEDN"
   #$01 don't need this now    addParamToGeneralConf PolicyDir_SSLKeyfile_Password "$KEYFILEPWD"
   #$01 don't need this now fi
fi

if [ "$WESENV" = "NO" ]
  then

 addParamToGeneralConf PolicyDir_DB_Mode "local"
 addParamToGeneralConf PolicyDir_DB_File "$WSLCONFDIR/wsl.db"
 addParamToGeneralConf PolicyDir_Audit_File "$WSLCONFDIR/wsl.audit"
fi #endof wesenv = no



if [ "$WESENV" = "NO" ]
  then

  #**************************************
  #   Enable ssl-listen-port for refresh#
  #**************************************
  addParamToGeneralConf PolicyDir_Listen_Flags "\"enable\""
fi 


#**************************************
#   Link Libraries to /usr/lib        #
#**************************************
# TO DO: Check if we want to do any of tihs at all
# TO DO: Set LIBPATH for various OS.  LIBPATH needs to include the jdk libraries
CREATEDUSRLIBLINK=NO
ln -fs  $PLUGINNAME /usr/lib/$PLUGINLIBNAME
rc=$?
if [ $rc -eq 0 ]
  then
    CREATEDUSRLIBLINK=YES  
fi




#**************************************
#   Kill WTE if Running       	      #
#**************************************
killServer ibmproxy


#**************************************
#   Configure WTE to use the plugin   #
#**************************************
CONFIGUREDWTE=NO
configureWTE $IBMPROXYCONF NO
for conf_file in `find $WTEINSTALLDIR -type f -name ibmproxy.conf`
do
    configureWTE "$conf_file" YES
done

CONFIGUREDWTE=YES

#**************************************
#   Attempt to create LTPA cookie file    #
#**************************************
addParamToGeneralConf LTPA_Cookie_Enabled "no"
#createLTPA_cookie_file


# Copy the query_contents utility into cgi-bin.
# TO DO: Uncomment the following line once the location of query contents is known
COPYQUERYCONTENTS=NO
[ -f $SERVERROOT/cgi-bin/query_contents ] && chmod +w $SERVERROOT/cgi-bin/query_contents
cat $QUERYCONTENTS | sed "s#^DOCROOTDIR=#DOCROOTDIR=$SERVERROOT#" > $SERVERROOT/cgi-bin/query_contents
rc=$?
if [ $rc -ne 0 ]
  then
    $PDRDAMSG pdwslshmsg.cat "$MSG_CP_QUERYCONENT_ERROR" "ERROR: Unable to copy the query_contents file.Please check the file permissions." 
    exitFailure 
else
   chmod +x $SERVERROOT/cgi-bin/query_contents
   COPYQUERYCONTENTS=YES
fi


#**************************************
#   Update Object Space Mapping       #
#**************************************
configureObjectSpace
addParamToGeneralConf ObjectSpace_File "$OSDEFCONF"



if [ "$WESENV" = "NO" ]
  then

#**********************************************
#   Set up /WTESeal/CURRENTHOSTNAME Object Space      
#**********************************************
OBJSPACE=`$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" object list | awk '{if($1=="'$BRANCH'") {print $1} }'`
if [ -z "$OBJSPACE" ]; then
   $PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" objectspace create "$BRANCH" "Access Manager Plug-in for Edge Server Object Space" 10  >> $ERRORLOG 2>&1
   rc=$?
   if [ $rc -ne 0 ]
     then
       $PDRDAMSG pdwslshmsg.cat "$MSG_OBJSPACESETUP_ERROR" "ERROR: Unable to create Object Space." 
        exitFailure 
   fi
fi
fi


#SETUPOBJECTSPACE=NO
#OBJSPACE=`$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" object list "$BRANCH" | awk '{if($1=="'$CURRENTHOSTNAME'") {print $1} }'`
#if [ -z "$OBJSPACE" ]; then
#    OBJECTCOMMENT="WTE Server"
#    $PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" object create "$BRANCH/$CURRENTHOSTNAME" "$OBJECTCOMMENT" 8 ispolicyattachable yes >> $ERRORLOG 2>&1
#     rc=$?
#     if [ $rc -ne 0 ]
#       then
#         $PDRDAMSG pdwslshmsg.cat "$MSG_OBJCREATE_ERROR" "ERROR: Unable to create object." 
#          exitFailure 
#     fi
#  SETUPOBJECTSPACE=YES
#else
#    # do not conitnue if already in object space    
#    echo "$OBJSPACE" already exists
#    exit 0
#fi



if [ "$WESENV" = "NO" ]
  then

#***************************************************************
#   Set up /WTESeal/CURRENTHOSTNAME Acls For Running wesosm            #
#***************************************************************
# TO DO: Put checks in to make sure that everything worked after each call
ACLNAME="init-wteseal"
ACLCREATEOKAY=NO
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl create "$ACLNAME" >> $ERRORLOG 2>&1
rc=$?
if [ $rc -ne 0 ]
       then

         #attempt to detach and delete the acl
         $PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl detach "$BRANCH" > /dev/null 2>&1
         $PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl delete "$ACLNAME" > /dev/null 2>&1
         $PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl create "$ACLNAME" >> $ERRORLOG 2>&1
         rc=$?
         if [ $rc -ne 0 ]
            then
              $PDRDAMSG pdwslshmsg.cat "$MSG_ACLCREATE_ERROR" "ERROR: Unable to create ACL." 
              exitFailure 
         else
             ACLCREATEOKAY=YES
         fi
else
  ACLCREATEOKAY=YES
fi
fi

if [ "$WESENV" = "NO" ]
  then

ACLSETOKAY=NO
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl modify "$ACLNAME" set any-other Tx >> $ERRORLOG 2>&1
rc=$?
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl modify "$ACLNAME" set unauthenticated Tx >> $ERRORLOG 2>&1
rc2=$?
if [ $rc -ne 0 -o $rc2 -ne 0 ]
       then
         $PDRDAMSG pdwslshmsg.cat "$MSG_ACLMODIFY_ERROR" "ERROR: Unable to modify ACL." 
          exitFailure 
else
   ACLSETOKAY=YES
fi

ACLATTACH=NO
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl attach "$BRANCH" "$ACLNAME" >> $ERRORLOG 2>&1
rc=$?
if [ $rc -ne 0 ]
       then
         $PDRDAMSG pdwslshmsg.cat "$MSG_ACLATTACH_ERROR" "ERROR: Unable to attach ACL to object." 
          exitFailure 
else
   ACLATTACH=YES
fi

fi #end of wesvn = no

if [ "$WESENV" = "YES" ]
  then
     addParamToGeneralConf AuthMethod  "LDAP"
fi


if [ "$WESENV" = "NO" ]
  then

   #***********************************
   # Create the WebSEAL Failover cookie 
   #   key file.
   #**************************************
   $WSLBINDIR/cdsso_key_gen $WEBSEALFAILOVERKEYFILE >> $ERRORLOG 2>&1
   rc=$?
   if [ $rc -ne 0 ]
       then
         $PDRDAMSG pdwslshmsg.cat "$MSG_FAILOVER_COOKIE_ERROR" "Error: WebSEAL Fail-Over Cookie creation failed\n"
         exitFailure 
   else
         addParamToGeneralConf WebSEAL_Cookie_Enabled "yes"
         addParamToGeneralConf WebSEAL_Cookie_Keyfile "$WEBSEALFAILOVERKEYFILE"
   fi
fi



#**************************************
#   Start ibmproxy  	  	      #
#**************************************
$PDRDAMSG pdwslshmsg.cat "$MSG_STARTING_WTE" "Starting WTE..."
createWTE_startfile
$STARTWTE
sleep 10


if [ "$WESENV" = "NO" ]
  then

#**************************************
#   Update PD Object Space Mapping    #q
#**************************************
# TO DO: This needs to be unit tested
#        Uncomment the following line
#echo run wesosm
createWTE_wesosm_file
$STARTWESOSM -run -verbose  -infile "$OSDEFCONF" 
rc=$?
if [ $rc -ne 0 ]
       then
         QMSG=`$PDRDAMSG pdwslshmsg.cat "$MSG_WESOSM_ERROR" "ERROR: Updating Object space with "`
         echo ${QMSG} "$WESOSM."
         exitFailure 
fi


#***************************************************************
#   Remove and Delete the temporary acl on the WTE OS           #
#***************************************************************
# TO DO: Put checks in to make sure that everything worked after each call
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl detach "$BRANCH" >> $ERRORLOG 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl delete "$ACLNAME" >> $ERRORLOG 2>&1

#***************************************************************
#   Create the default acl for sec_master #
#***************************************************************
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl detach "$BRANCH" > /dev/null 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl delete "$DEFAULTACL" > /dev/null 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl create "$DEFAULTACL" >> $ERRORLOG 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl modify "$DEFAULTACL" set any-other T >> $ERRORLOG 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl modify "$DEFAULTACL" set unauthenticated T >> $ERRORLOG 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl modify "$DEFAULTACL" set user sec_master Tcmdbvarxl >> $ERRORLOG 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl attach "$BRANCH" "$DEFAULTACL" >> $ERRORLOG 2>&1

#***************************************************************
#   Create the default acl that will allow unauthenticated 
#   users to access WTE error pages
#***************************************************************
if [ $WTE_VER -eq 3 ]
  then
    ICONSDIR=icons
 else
    ICONSDIR=cpicons
fi

$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl detach "$BRANCH/$CURRENTHOSTNAME/Docs" > /dev/null 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl detach "$BRANCH/$CURRENTHOSTNAME/$ICONSDIR" > /dev/null 2>&1 

$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl delete "$DEFAULTUNAUTHACL" > /dev/null 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl create "$DEFAULTUNAUTHACL" >> $ERRORLOG 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl modify "$DEFAULTUNAUTHACL" set any-other Trx >> $ERRORLOG 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl modify "$DEFAULTUNAUTHACL" set unauthenticated Trx >> $ERRORLOG 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl modify "$DEFAULTUNAUTHACL" set user sec_master Tcmdbvarxl >> $ERRORLOG 2>&1

$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl attach "$BRANCH/$CURRENTHOSTNAME/Docs" "$DEFAULTUNAUTHACL" >> $ERRORLOG 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl attach "$BRANCH/$CURRENTHOSTNAME/$ICONSDIR" "$DEFAULTUNAUTHACL" >> $ERRORLOG 2>&1

#***************************************************************
#   Create the default acl that will allow authenticated 
#   users to access the forward branch
#***************************************************************
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl detach "$BRANCH/forward" > /dev/null 2>&1

$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl delete "$DEFAULTANYOTHERACL" > /dev/null 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl create "$DEFAULTANYOTHERACL" >> $ERRORLOG 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl modify "$DEFAULTANYOTHERACL" set any-other Trx >> $ERRORLOG 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl modify "$DEFAULTANYOTHERACL" set unauthenticated T >> $ERRORLOG 2>&1
$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl modify "$DEFAULTANYOTHERACL" set user sec_master Tcmdbvarxl >> $ERRORLOG 2>&1

$PDRTEDIR/pdadmin -a "$ADMINUSER" -p "$ADMINPASSWORD" acl attach "$BRANCH/forward" "$DEFAULTANYOTHERACL" >> $ERRORLOG 2>&1



TEST=`$PDRDACONF -o -f $OSDEFCONF -l -L $BRANCH/$CURRENTHOSTNAME -P query_interval`
if [ -n "$TEST" ]; then
      $PDRDACONF -o -f $OSDEFCONF -d -L $BRANCH/$CURRENTHOSTNAME -P query_interval
fi

$PDRDACONF -o -f $OSDEFCONF -a -L $BRANCH/$CURRENTHOSTNAME -P query_interval 0

fi #end of wesvn = no

############################################################
#Concatenate the ibmepsas.conf.template to the ibmwesas.conf
#and add wes specific parms to config file.
############################################################
if [ "$COPYWESCONF" = "TRUE" ]
  then
    addParamToGeneralConf WES_Support "YES"

    CATINDICATOR="#addedwesparms"

  #Make sure cat only occurs 1 time.
  ADDEDWESCONF=`cat $GENERALCONF | awk '{if ($1=="'$CATINDICATOR'") {print $0} }'`
  if [ -z "$ADDEDWESCONF" ]
   then
     echo $CATINDICATOR >> $GENERALCONF
     cat $WESCONF >> $GENERALCONF
  fi

fi

  
$PDRDAMSG pdwslshmsg.cat "$MSG_CONFIG_COMPLETE" "Configuration Completed."

