/*
 * File Name: xauthn.h
 *
 * Licensed Materials - Property of IBM
 * 5748-XX8
 * (c) Copyright International Business Machines Corp. 2002
 * All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplicaion or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

#ifndef XAUTHN_H
#define XAUTHN_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#if !defined(WIN32) && !defined(_WIN32)
#include <strings.h>
#endif 

#include "pdxauthn.h"
#include "xattr.h"
#include "xnvlist.h"



/* Uncomment to build a DCE identity */
#define BUILD_LDAP_USER

/************************
 Macro Definitions
************************/
#ifdef WIN32
#define STRCASECMP                      _stricmp
#define STRNCASECMP                     _strnicmp
#elif SOLARIS
#define STRCASECMP                      strcasecmp
#define STRNCASECMP                     strncasecmp
#else
#define STRCASECMP                      strcasecmp
#define STRNCASECMP                     strncasecmp
#endif

#define SELECTED(x,y)                   STRCASECMP(x,y) == 0

#define BIGDATASIZE 2000

#define DEMOOTHERDATA    0
#define DEMOUSER         1
#define DEMOUSERPASS     2
#define DEMOCERTDN       3
#define VALIDPDDN        4

#define UNSUPPORTED_AUTH 0
#define BASIC_AUTH       1
#define CERT             2
#define SSO              3

typedef struct {
    char demo_user[BIGDATASIZE];
    char demo_user_password[BIGDATASIZE];
    char demo_cert_dn[BIGDATASIZE];
    char demo_validpddn[BIGDATASIZE];
} demo_data;


/*Internal Function Prototypes */
int init_arg_type(char * argtotest);
int getOptionValue(int * arg_num,int argc, char ** argv,char * option_buffer);
int check_basic_auth(xnvlist_t *authnInfo);
int check_certdn(xnvlist_t *authnInfo);
int does_name_exist_in_list(char * name_to_check,xnvlist_t *authnInfo);

#endif
