#ifdef __cplusplus
extern "C" {
#endif

/* @(#)18 1.2 adks/toolkits/cdas/external/include/xattr.h, pdwsl.src, pdwsl390, 020410a 1/22/02 16:03:25
 *
 * Component Name: CDAS ADK
 * File Name: xattr.h
 *
 * Licensed Materials - Property of IBM
 * 5748-XX8
 * (c) Copyright International Business Machines Corp. 2001
 * US Government Users Restricted Rights - Use, duplicaion or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * All Rights Reserved.
 */
/*
 * xattr.h
 *
 * External attributes utility functions
 */

#ifndef XATTR_H
#define XATTR_H


typedef struct {
    char *name;
    char *value;
} xattr_list_item_t;

typedef struct {
    long               length;
    xattr_list_item_t  *items;
} xattr_list_t;


/*
 * Allocates an xattr_list_t and returns it.  Returns NULL on allocation
 * failure.
 */
xattr_list_t*
xattr_malloc(int list_size);

/*
 * Frees an xattr_list_t and any items in the list.
 */
void
xattr_free(xattr_list_t *list);

/*
 * Return a pointer pointing to the value of 
 * the specified name in the xattr.
 */
int
xattr_get(xattr_list_t *list, char *name, char **value);

/*
 * Set the name/value pair to the xattr.
 */
int 
xattr_set(xattr_list_t *list, char *name, char *value);

/*
 * Duplicate the xnvlist.
 */
xattr_list_t *
xattr_dup(xattr_list_t *list);

/*
 * Duplicate the items in the xattr.
 */
xattr_list_item_t *
xattr_items_dup(xattr_list_t *list);

#endif /* end XATTR_H */
#ifdef __cplusplus
}
#endif
