#ifdef __cplusplus
extern "C" {
#endif

/* @(#)19 1.2 adks/toolkits/cdas/external/include/xnvlist.h, pdwsl.src, pdwsl390, 020410a 1/22/02 16:03:28
 *
 * Component Name: CDAS ADK
 * File Name: xnvlist.h
 *
 * Licensed Materials - Property of IBM
 * 5748-XX8
 * (c) Copyright International Business Machines Corp. 2001
 * US Government Users Restricted Rights - Use, duplicaion or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * All Rights Reserved.
 */
/*
 * xnvlist.h
 *
 * List of name-value pairs.
 */

#ifndef XNVLIST_H
#define XNVLIST_H

typedef struct {
    char *name; 
    char *value;
    int  vlen;
} xnvlist_item_t;

typedef struct {
    long            length; /* number of items in list */
    xnvlist_item_t   *items; /* array of list elements. */
} xnvlist_t;


/*
 * Return a pointer pointing to the value of 
 * the specified name in the xnvlist.
 */
int
xnvlist_get(xnvlist_t *list, char *name, char **value, int *vlen);


#endif /* end XNVLIST_H */
#ifdef __cplusplus
}
#endif
